package splitimageviewwrapper;

import main.java.com.alihafizji.splitimageview.SplitImageView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("SplitImageView")
public class splitImageViewWrapper extends ViewWrapper<SplitImageView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private SplitImageView cv;
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new SplitImageView(ba.context);
                this.setObject(cv);
//                setEventName(this.eventName);
//                addListener();
 	}


//        @Hide
//        public void setEventName(String en){
//            cv.setEventName(en);
//            cv.invalidate(); 
//       }


//    @Hide
//    public void addListener(){
//        cv.setCallback(new PopSeekBarView.Callback() {
//            @Override
//            public void value_changed() {

//              if (ba.subExists(eventName + "_value_changed")) {
//                ba.raiseEvent2(ba, false, eventName + "_value_changed", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }


//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

    /**
     * Sets a Bitmap as the background content of this SplitImageView.
     *
     */
    public void setBackgroundImageBitmap(Bitmap bm) {
        // if this is used frequently, may handle bitmaps explicitly
        // to reduce the intermediate drawable object
        cv.setBackgroundImageBitmap(bm);
        cv.invalidate();
    }

    /**
     * Sets a Bitmap as the foreground content of this SplitImageView.
     *
     */
    public void setForegroundImageBitmap(Bitmap bm) {
        // if this is used frequently, may handle bitmaps explicitly
        // to reduce the intermediate drawable object
        cv.setForegroundImageBitmap(bm);
        cv.invalidate();
    }


    /**
     * Enables the touch to unveil feature
     * @param unveilOnTouch
     */
    public void setUnveilOnTouch(boolean unveilOnTouch) {
        cv.setUnveilOnTouch(unveilOnTouch);
        cv.invalidate();
    }


    /**
     * Sets a Bitmap as the background content of this SplitImageView.
     *
     */
    public void setBackgroundImageDrawable(Drawable drawable) {
        cv.setBackgroundImageDrawable(drawable);
        cv.invalidate(); 
    }

    /**
     * Sets a Bitmap as the foreground content of this SplitImageView.
     *
     */
    public void setForegroundImageDrawable(Drawable drawable) {
        cv.setForegroundImageDrawable(drawable);
        cv.invalidate(); 
    }


    public void setColorFilter(int color) {                                 
        cv.setColorFilter(color);
        cv.invalidate();
    }

    public void clearColorFilter() {                                       
        cv.clearColorFilter();
        cv.invalidate();
    }



    public boolean isEnableAutomaticAnimation() {
        return cv.isEnableAutomaticAnimation();
    }

    /**
     * Will enable automatic animation. For this to work the foreground drawable and background
     * drawable will have to be set. Also when enabled touch unveil will not work.
     */
    public void setEnableAutomaticAnimation(boolean enable) {
        cv.setEnableAutomaticAnimation(enable);
        cv.invalidate();
    }

    /**
     * This method will set the percentage of split that is applied to the Images.
     * Lesser the value more the amount that is reveled.
     * By default this is 50%.
     *
     */
    public void setSplitPercent(int percent) {
        cv.setSplitPercent(percent);
        cv.invalidate();
    }

    /**
     * Returns the alpha that will be applied to the drawables of this SplitImageView.
     *
     */
    public int getImageAlpha() {
        return cv.getImageAlpha();
    }

    /**
     * Sets the alpha value that should be applied to the image.
     *
     */
    public void setImageAlpha(int alpha) {
        cv.setImageAlpha(alpha);
    }

    public int getAutomaticAnimationDuration() {
        return cv.getAutomaticAnimationDuration();
    }

    /**
     * Set the duration of the automatic animation.
     * If the automatic animation has already started this wont take effect.
     * Call this before calling setEnableAutomaticAnimation
     */
    public void setAutomaticAnimationDuration(int automaticAnimationDuration) {
        cv.setAutomaticAnimationDuration(automaticAnimationDuration);
        cv.invalidate();
    }




}
